diff --git a/web/app/controllers/daemon_controller.rb b/web/app/controllers/daemon_controller.rb
new file mode 100644
index 00000000..a6e5d1aa
--- /dev/null
+++ b/web/app/controllers/daemon_controller.rb
@@ -0,0 +1,28 @@
+# frozen_string_literal: true
+
+class DaemonController < ApplicationController
+  # POST /daemon/repair — enqueue exact allowlisted
+  # `hive daemon install --force` for a running daemon to consume.
+  def repair
+    require "hive/daemon/status_report"
+    report = Hive::Daemon::StatusReport.new.safe_payload
+
+    unless report["running"]
+      raise Hive::Error,
+            "daemon is not running — repair cannot be queued. " \
+            "Run `hive daemon install --force` from a terminal, then `hive daemon start`."
+    end
+
+    drift = report["binary_drift"].to_s
+    unless %w[path version unparseable].include?(drift)
+      raise Hive::Error,
+            "daemon binary drift is #{drift.inspect}; repair is only offered for " \
+            "path/version/unparseable drift"
+    end
+
+    request_id = Hive::Web::Dispatcher.new.queue_daemon_repair!
+    redirect_to root_path,
+                notice: "Daemon repair queued (#{request_id}). " \
+                        "The running daemon will reinstall its unit with the current binary."
+  end
+end
diff --git a/web/app/controllers/status_controller.rb b/web/app/controllers/status_controller.rb
index c44440a8..a217f00b 100644
--- a/web/app/controllers/status_controller.rb
+++ b/web/app/controllers/status_controller.rb
@@ -2,5 +2,20 @@ class StatusController < ApplicationController
   def index
     @payload = StatusBroadcaster.snapshot
     @projects = @payload.fetch("projects", [])
+    @daemon = daemon_status_payload
+  end
+
+  private
+
+  def daemon_status_payload
+    require "hive/daemon/status_report"
+    Hive::Daemon::StatusReport.new.safe_payload
+  rescue StandardError => e
+    {
+      "running" => false,
+      "binary_drift" => "unreadable",
+      "error" => "#{e.class}: #{e.message}"
+    }
   end
 end
+
diff --git a/web/app/views/status/_daemon.html.erb b/web/app/views/status/_daemon.html.erb
new file mode 100644
index 00000000..8297f179
--- /dev/null
+++ b/web/app/views/status/_daemon.html.erb
@@ -0,0 +1,61 @@
+<%# Locals: daemon (Hash from StatusReport#safe_payload) %>
+<% daemon = local_assigns.fetch(:daemon) { {} } %>
+<% running = daemon["running"] %>
+<% drift = daemon["binary_drift"].to_s %>
+<% actionable = running && %w[path version unparseable].include?(drift) %>
+<section class="daemon-health" aria-label="Daemon health">
+  <h2 class="daemon-health-title">Daemon</h2>
+  <dl class="daemon-health-grid">
+    <div>
+      <dt>Status</dt>
+      <dd>
+        <% if running %>
+          <span class="badge badge-ok">running</span>
+          <% if daemon["pid"] %>pid <%= daemon["pid"] %><% end %>
+        <% else %>
+          <span class="badge badge-down">down</span>
+        <% end %>
+      </dd>
+    </div>
+    <div>
+      <dt>Service</dt>
+      <dd>
+        <% if daemon["service_installed"] %>
+          installed<%= daemon["service_enabled"] ? ", enabled" : "" %>
+        <% elsif daemon["service_installed"].nil? %>
+          unknown
+        <% else %>
+          not installed
+        <% end %>
+      </dd>
+    </div>
+    <div>
+      <dt>Binary drift</dt>
+      <dd>
+        <code><%= drift.empty? ? "unknown" : drift %></code>
+        <% if daemon["installed_binary"] || daemon["expected_binary"] %>
+          <div class="muted small">
+            installed: <%= daemon["installed_binary"].inspect %><br>
+            expected: <%= daemon["expected_binary"].inspect %><br>
+            installed version: <%= daemon["installed_version"].inspect %> /
+            current: <%= daemon["current_version"].inspect %>
+          </div>
+        <% end %>
+      </dd>
+    </div>
+  </dl>
+
+  <% if actionable %>
+    <%= button_to "Repair daemon unit", daemon_repair_path, method: :post,
+          class: "btn btn-sm",
+          form: { data: { turbo_confirm: "Queue hive daemon install --force on the running daemon?" } } %>
+  <% elsif !running %>
+    <p class="muted small">
+      Daemon is down — repair cannot be queued. Run
+      <code>hive daemon install --force</code> then
+      <code>hive daemon start</code> from a terminal.
+    </p>
+  <% elsif drift == "none" %>
+    <p class="muted small">Daemon unit matches this CLI binary.</p>
+  <% end %>
+</section>
diff --git a/web/app/views/status/index.html.erb b/web/app/views/status/index.html.erb
index 25bcdf79..4135ace7 100644
--- a/web/app/views/status/index.html.erb
+++ b/web/app/views/status/index.html.erb
@@ -26,6 +26,8 @@
   </aside>
   <div class="status-main">
 
+<%= render "status/daemon", daemon: @daemon || {} %>
+
 <%# data-turbo-permanent: a morph must never touch the composer — it holds
     typed-but-unsent idea text and staged image attachments (Stimulus state
     the server can't re-render). %>
diff --git a/web/config/initializers/hive.rb b/web/config/initializers/hive.rb
index f2792b55..12b51250 100644
--- a/web/config/initializers/hive.rb
+++ b/web/config/initializers/hive.rb
@@ -3,6 +3,7 @@
 require "hive"
 require "hive/media_manifest"
 require "hive/web/github_auth"
+require "hive/web/loopback"
 require "hive/web/status_feed"
 require "hive/web/dispatcher"
 require "hive/web/agents_auth"
diff --git a/web/config/routes.rb b/web/config/routes.rb
index 659576df..230524d0 100644
--- a/web/config/routes.rb
+++ b/web/config/routes.rb
@@ -17,6 +17,8 @@ Rails.application.routes.draw do
 
   root "status#index"
 
+  post "daemon/repair" => "daemon#repair", as: :daemon_repair
+
   post "ideas" => "ideas#create", as: :ideas
 
   # Task pages are addressed by project name + task slug, mirroring the CLI.
diff --git a/web/test/e2e/golden_path_e2e.rb b/web/test/e2e/golden_path_e2e.rb
index 5d6c8302..0bc5bfe9 100644
--- a/web/test/e2e/golden_path_e2e.rb
+++ b/web/test/e2e/golden_path_e2e.rb
@@ -1,5 +1,7 @@
 require "application_system_test_case"
 require "open3"
+require "hive/tui/bubble_model"
+require "hive/tui/state_source"
 
 # The hivebox golden path, end to end, in a real browser — deliberately NOT
 # named *_test.rb so the default suites skip it; run it explicitly:
@@ -36,6 +38,8 @@ class GoldenPathE2E < ApplicationSystemTestCase
   end
 
   setup do
+    @original_path = ENV["PATH"]
+    ENV["PATH"] = [ File.join(REPO_ROOT, "bin"), @original_path ].compact.join(File::PATH_SEPARATOR)
     configure_owner!(owner: "") # claimable box
     speed_up_daemon!
     @project = create_hive_project!("golden-app")
@@ -52,6 +56,7 @@ class GoldenPathE2E < ApplicationSystemTestCase
     end
     StatusBroadcaster.stop!
     SessionsController.http_client = Net::HTTP
+    ENV["PATH"] = @original_path
     # The sandbox vanishes with the process — on failure, keep the daemon's
     # own event log and the task tree where a human can read them.
     unless passed?
@@ -149,8 +154,66 @@ class GoldenPathE2E < ApplicationSystemTestCase
                     "the fake agent's commit must be a real commit in a real worktree"
   end
 
+  test "TUI and web ideas share one state tree and both auto-dispatch" do
+    sign_in!(login: "goldenpath")
+
+    tui_title = "TUI parity idea"
+    submit_tui_idea!(tui_title)
+    visit "/"
+    assert_selector ".task-row", text: tui_title, wait: 10,
+                    message: "an idea submitted through the real TUI model must appear in Rails"
+    tui_slug = task_slug_from_grid!(tui_title)
+    wait_for_daemon_dispatch!(tui_slug)
+
+    web_title = "Web parity idea"
+    fill_in "New idea", with: web_title
+    find(".composer select[name='project']").find("option[value='#{@project}']").select_option
+    click_button "Add idea"
+    assert_selector ".task-row", text: web_title, wait: 10
+    web_slug = task_slug_from_grid!(web_title)
+
+    snapshot = Hive::Tui::StateSource.new.refresh_now
+    assert snapshot.rows.any? { |row| row.slug == web_slug && row.display_name == web_title },
+           "an idea submitted through Rails must appear in the TUI's real StateSource snapshot"
+    wait_for_daemon_dispatch!(web_slug)
+  end
+
   private
 
+  def submit_tui_idea!(title)
+    snapshot = Hive::Tui::StateSource.new.refresh_now
+    bubble = Hive::Tui::BubbleModel.new(
+      hive_model: Hive::Tui::Model.initial.with(
+        mode: :new_idea,
+        snapshot: snapshot,
+        scope: 0,
+        new_idea_project_name: @project,
+        new_idea_buffer: title,
+        new_idea_cursor: title.length
+      )
+    )
+
+    capture_io { bubble.update(Hive::Tui::Messages::NEW_IDEA_SUBMITTED) }
+    assert_equal :grid, bubble.hive_model.mode
+    assert_match(/\A\+ /, bubble.hive_model.flash.to_s,
+                 "the TUI must report a successful real `hive new` subprocess")
+  end
+
+  def wait_for_daemon_dispatch!(slug, timeout: 30)
+    events = File.join(ENV["HIVE_HOME"], "logs", "daemon.log")
+    deadline = Process.clock_gettime(Process::CLOCK_MONOTONIC) + timeout
+    loop do
+      log = File.exist?(events) ? File.read(events) : ""
+      return if log.lines.any? { |line| line.include?(slug) && line.include?('"event":"dispatched"') }
+
+      if Process.clock_gettime(Process::CLOCK_MONOTONIC) > deadline
+        raise "daemon never auto-dispatched #{slug}"
+      end
+
+      sleep 0.1
+    end
+  end
+
   # The status grid is Turbo-replaced while the daemon advances tasks. Read the
   # slug from a single current-DOM query instead of retaining a Capybara element.
   def task_slug_from_grid!(title, timeout: 10)
diff --git a/web/test/integration/local_loopback_auth_test.rb b/web/test/integration/local_loopback_auth_test.rb
new file mode 100644
index 00000000..6f84bb7c
--- /dev/null
+++ b/web/test/integration/local_loopback_auth_test.rb
@@ -0,0 +1,71 @@
+# frozen_string_literal: true
+
+require "test_helper"
+
+class LocalLoopbackAuthTest < ActionDispatch::IntegrationTest
+  setup do
+    @previous_mode = ENV[Hive::Web::Loopback::ENV_MODE]
+  end
+
+  teardown do
+    if @previous_mode.nil?
+      ENV.delete(Hive::Web::Loopback::ENV_MODE)
+    else
+      ENV[Hive::Web::Loopback::ENV_MODE] = @previous_mode
+    end
+  end
+
+  test "loopback peer with mode enabled reaches protected page without session" do
+    ENV[Hive::Web::Loopback::ENV_MODE] = "1"
+    # Default remote_ip in integration tests is 127.0.0.1
+    get root_path
+    assert_response :success
+    assert_nil session[:github_login]
+  end
+
+  test "local_loopback false restores login redirect even when mode env is set" do
+    ENV[Hive::Web::Loopback::ENV_MODE] = "1"
+    path = Hive::Config.global_config_path
+    FileUtils.mkdir_p(File.dirname(path))
+    existing = File.exist?(path) ? YAML.safe_load(File.read(path)) || {} : {}
+    existing = {} unless existing.is_a?(Hash)
+    existing["web"] = (existing["web"] || {}).merge("local_loopback" => false)
+    File.write(path, existing.to_yaml)
+
+    get root_path
+    assert_redirected_to login_path
+  ensure
+    # Leave config as tests usually use isolated HIVE_HOME; best-effort restore.
+    if defined?(path) && File.exist?(path)
+      data = YAML.safe_load(File.read(path)) || {}
+      if data.is_a?(Hash) && data["web"].is_a?(Hash)
+        data["web"].delete("local_loopback")
+        File.write(path, data.to_yaml)
+      end
+    end
+  end
+
+  test "non-loopback peer never bypasses login even with mode env" do
+    ENV[Hive::Web::Loopback::ENV_MODE] = "1"
+    get root_path, headers: { "REMOTE_ADDR" => "8.8.8.8" }
+    assert_redirected_to login_path
+  end
+
+  test "non-loopback Host never bypasses login for a loopback peer" do
+    ENV[Hive::Web::Loopback::ENV_MODE] = "1"
+    get root_path, headers: { "HOST" => "attacker.example" }
+    assert_redirected_to login_path
+  end
+
+  test "loopback Host with an explicit port keeps the local bypass" do
+    ENV[Hive::Web::Loopback::ENV_MODE] = "1"
+    get root_path, headers: { "HOST" => "127.0.0.1:4567" }
+    assert_response :success
+  end
+
+  test "mode disabled requires login on loopback" do
+    ENV.delete(Hive::Web::Loopback::ENV_MODE)
+    get root_path
+    assert_redirected_to login_path
+  end
+end
